#include "StdAfx.h"
#include "SliderScriptletPlugin.h"

#include "NSlider.h"
#include "ScriptletConstant.h"
#include "XMLUtil.h"
#include "SliderDefUI.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_SLIDER_NODE, CSliderScriptletPlugin);
CSliderScriptletPlugin::CSliderScriptletPlugin(void)
{
}

CSliderScriptletPlugin::~CSliderScriptletPlugin(void)
{
}
BOOL CSliderScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CNSlider* pSlider = reinterpret_cast<CNSlider*>(pTarget);
		if (pSlider == NULL)
		{
			return bSuccess;
		}
		CSliderDefUI::SLIDERDEFUI_ITEM sliderUiItem;
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;
		BOOL bHorz = TRUE;

		USES_CONVERSION;

		// dir
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_DIR_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_DIR_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			bHorz = _tcsicmp(szValue, SCRIPTLET_HORZ_VALUE) == 0;
			CNSlider::eDirection eDir = bHorz ? CNSlider::E_SLIDER_DIRECTION_HORZ : CNSlider::E_SLIDER_DIRECTION_VERT;
			pSlider->SetDirection(eDir);
		}

		// min
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_MIN_NODE), lValue) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_MIN_NODE), lValue))
		{
			pSlider->SetMinValue(lValue);
		}

		// max
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_MAX_NODE), lValue) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_MAX_NODE), lValue))
		{
			pSlider->SetMaxValue(lValue);
		}

		// pos
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_POS_NODE), lValue) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_POS_NODE), lValue))
		{
			pSlider->SetPosValue(lValue);
		}

		// rail
		CStringA strRailElement = pNode->Value();
		strRailElement.Append(".");
		strRailElement.Append(CT2CA(SCRIPTLET_RAIL_NODE));
		TiXmlElement* pRailNode = pNode->FirstChildElement(strRailElement);
		if (pRailNode)
		{
			CRect rcRail;
			// x
			if (XMLUtil::GetAttrValue(pRailNode, CT2CA(SCRIPTLET_X_NODE), lValue))
			{
				rcRail.MoveToX(lValue);
			}
			// y
			if (XMLUtil::GetAttrValue(pRailNode, CT2CA(SCRIPTLET_Y_NODE), lValue))
			{
				rcRail.MoveToY(lValue);
			}
			// width
			if (XMLUtil::GetAttrValue(pRailNode, CT2CA(SCRIPTLET_WIDTH_NODE), lValue))
			{
				rcRail.right = rcRail.left + lValue;
			}
			// height
			if (XMLUtil::GetAttrValue(pRailNode, CT2CA(SCRIPTLET_HEIGHT_NODE), lValue))
			{
				rcRail.bottom = rcRail.top + lValue;
			}

			pSlider->SetRailRect(&rcRail);
		}

		// lefttop
		CStringA strLTElement = pNode->Value();
		strLTElement.Append(".");
		strLTElement.Append(CT2CA(SCRIPTLET_LEFTTOP_NODE));
		TiXmlElement* pLTNode = pNode->FirstChildElement(strLTElement);
		if (pLTNode)
		{
			TiXmlElement* pImgNode = pLTNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
			if (pImgNode)
			{
				// src
				if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
					XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
				{
					IImage* pImage = LoadImage(szValue);
					if (pImage)
					{
						sliderUiItem.pImgBgLeftTop = pImage;
					}
				}
			}
		}

		// rightbottom
		CStringA strRTElement = pNode->Value();
		strRTElement.Append(".");
		strRTElement.Append(CT2CA(SCRIPTLET_RIGHTBOTTOM_NODE));
		TiXmlElement* pRTNode = pNode->FirstChildElement(strRTElement);
		if (pRTNode)
		{
			TiXmlElement* pImgNode = pRTNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
			if (pImgNode)
			{
				// src
				if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
					XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
				{
					IImage* pImage = LoadImage(szValue);
					if (pImage)
					{
						sliderUiItem.pImgBgRightBottom = pImage;
					}
				}
			}
		}

		// center
		CStringA strCenterElement = pNode->Value();
		strCenterElement.Append(".");
		strCenterElement.Append(CT2CA(SCRIPTLET_CENTER_NODE));
		TiXmlElement* pCenterNode = pNode->FirstChildElement(strCenterElement);
		if (pCenterNode)
		{
			TiXmlElement* pImgNode = pCenterNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
			if (pImgNode)
			{
				// src
				if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
					XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
				{
					IImage* pImage = LoadImage(szValue);
					if (pImage)
					{
						sliderUiItem.pImgBgCenter = pImage;
					}
				}
			}
		}

		// past
		CStringA strPastElement = pNode->Value();
		strPastElement.Append(".");
		strPastElement.Append(CT2CA(SCRIPTLET_CENTER_NODE));
		TiXmlElement* pPastNode = pNode->FirstChildElement(strPastElement);
		if (pPastNode)
		{
			TiXmlElement* pImgNode = pPastNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
			if (pImgNode)
			{
				// src
				if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
					XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
				{
					IImage* pImage = LoadImage(szValue);
					if (pImage)
					{
						sliderUiItem.pImgPast = pImage;
					}
				}
			}
		}

		// thumb
		CStringA strThumbElement = pNode->Value();
		strThumbElement.Append(".");
		strThumbElement.Append(CT2CA(SCRIPTLET_THUMB_NODE));
		TiXmlElement* pThumbNode = pNode->FirstChildElement(strThumbElement);
		if (pThumbNode)
		{
			CRect rcThumbStart;
			TiXmlElement* pImgNode = pThumbNode->FirstChildElement(CT2CA(SCRIPTLET_IMAGE_NODE));
			if (pImgNode)
			{
				// src
				if (XMLUtil::GetAttrValue(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
					XMLUtil::GetValueAsAttr(pImgNode, CT2CA(SCRIPTLET_SOURCE_NODE), szValue, SCRIPTLET_MAX_VALUE))
				{
					IImage* pImage = LoadImage(szValue);
					if (pImage)
					{
						sliderUiItem.pImgThumb = pImage;
						rcThumbStart.SetRect(0, 0, pImage->GetWidth()/4, pImage->GetHeight());
					}
				}
			}
			// x
			if (XMLUtil::GetAttrValue(pThumbNode, CT2CA(SCRIPTLET_X_NODE), lValue) || 
				XMLUtil::GetValueAsAttr(pThumbNode, CT2CA(SCRIPTLET_X_NODE), lValue) )
			{
				rcThumbStart.MoveToX(lValue);
			}
			// y
			if (XMLUtil::GetAttrValue(pThumbNode, CT2CA(SCRIPTLET_Y_NODE), lValue))
			{
				rcThumbStart.MoveToY(lValue);
			}
			// moving
			int nMoving;
			if (XMLUtil::GetAttrValue(pThumbNode, CT2CA(SCRIPTLET_MOVING_NODE), lValue))
			{
				nMoving = lValue;
			}

			pSlider->SetThumbStartRect(&rcThumbStart);

			CRect rcThumbEnd(&rcThumbStart);
			if (bHorz)
			{
				rcThumbEnd.OffsetRect(nMoving, 0);
			}
			else
			{
				rcThumbEnd.OffsetRect(0, nMoving);
			}
			pSlider->SetThumbEndRect(&rcThumbEnd);
		}

		m_pSliderDefUi.Attach(new CSliderDefUI(pSlider, &sliderUiItem));
		pSlider->SetUI(m_pSliderDefUi.m_p);

	}
	return bSuccess;
}
CComponent* CSliderScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CNSlider;
	return pComponent;
}